Get DeploymentFreezes
GET /api
Gets a paginated set of DeploymentFreezes.
Query Parameters
effectiveDatestring
URL encoded timestamp to search recurring deployment freezes at a given point in time. Formatdate-time.environmentIdsarray of string
List of Environment IDs which if specified, filters the result to only include DeploymentFreeze with matching Environment IDs.idsarray of string
List of DeploymentFreeze IDs which if specified, filters the result to only include DeploymentFreeze with matching IDs.includeCompleteboolean
Set to false to only return active Deployment Freezes.partialNamestring
A partial or complete name to search on. This will perform a “contains” style match against the supplied name or name-fragment.projectIdsarray of string
List of Project IDs which if specified, filters the result to only include DeploymentFreeze with matching Project IDs.skipinteger (required)
Number of items to skip. Defaults to zero. Minimum0.statusstringtakeinteger (required)
Number of items to take. Defaults to 30. Minimum0.tenantIdsarray of string
List of Tenant IDs which if specified, filters the result to only include DeploymentFreeze with matching Tenant IDs.
Response
200 — Requested list of DeploymentFreezes
CountintegerDeploymentFreezesarray of objectDescriptionstringEndstring
Formatdate-time.IdstringNamestring
Minimum length 1.ProjectEnvironmentScopeobjectRecurringScheduleobjectStartstring
Formatdate-time.TenantProjectEnvironmentScopearray of object
Example Response
{
"Count": 0,
"DeploymentFreezes": [
{
"Description": "string",
"End": "2020-01-01T00:00:00.000Z",
"Id": "string",
"Name": "string",
"ProjectEnvironmentScope": {
"additionalProp1": [
"string"
],
"additionalProp2": [
"string"
],
"additionalProp3": [
"string"
]
},
"RecurringSchedule": {
"EndAfterOccurrences": 0,
"EndDate": "2020-01-01T00:00:00.000Z",
"EndOnDate": "2020-01-01T00:00:00.000Z",
"EndType": "Never",
"StartDate": "2020-01-01T00:00:00.000Z",
"Type": "Daily",
"Unit": 0,
"UserUtcOffsetInMinutes": 0
},
"Start": "2020-01-01T00:00:00.000Z",
"TenantProjectEnvironmentScope": [
{}
]
}
]
}Create a new deployment freeze
POST /api
Request Body
DescriptionstringEndstring (required)
Formatdate-time.Namestring (required)
Minimum length 1. Maximum length 200.ProjectEnvironmentScopeobjectStartstring (required)
Formatdate-time.
Response
201 — Created
DescriptionstringEndstring
Formatdate-time.IdstringNamestring
Minimum length 1.ProjectEnvironmentScopeobjectRecurringScheduleobjectEndAfterOccurrencesintegerEndDatestring
Formatdate-time.EndOnDatestring
Formatdate-time.EndTypeenum
Allowed values:Never,OnDate,AfterOccurrences.StartDatestring
Formatdate-time.Typeenum
Allowed values:Daily,Weekly,Monthly,Annually.UnitintegerUserUtcOffsetInMinutesinteger
Startstring
Formatdate-time.TenantProjectEnvironmentScopearray of objectEnvironmentIdstringProjectIdstringTenantIdstring
Example Request
{
"Description": "string",
"End": "2020-01-01T00:00:00.000Z",
"Name": "string",
"ProjectEnvironmentScope": {
"additionalProp1": [
"string"
],
"additionalProp2": [
"string"
],
"additionalProp3": [
"string"
]
},
"Start": "2020-01-01T00:00:00.000Z"
}Example Response
{
"Description": "string",
"End": "2020-01-01T00:00:00.000Z",
"Id": "string",
"Name": "string",
"ProjectEnvironmentScope": {
"additionalProp1": [
"string"
],
"additionalProp2": [
"string"
],
"additionalProp3": [
"string"
]
},
"RecurringSchedule": {
"EndAfterOccurrences": 0,
"EndDate": "2020-01-01T00:00:00.000Z",
"EndOnDate": "2020-01-01T00:00:00.000Z",
"EndType": "Never",
"StartDate": "2020-01-01T00:00:00.000Z",
"Type": "Daily",
"Unit": 0,
"UserUtcOffsetInMinutes": 0
},
"Start": "2020-01-01T00:00:00.000Z",
"TenantProjectEnvironmentScope": [
{
"EnvironmentId": "Environments-1",
"ProjectId": "Projects-1",
"TenantId": "Tenants-1"
}
]
}Get a deployment freeze by ID
GET /api
Path Parameters
idstring (required)
Id of the deployment freeze.
Response
200 — The requested deployment freeze
DescriptionstringEndstring
Formatdate-time.IdstringNamestring
Minimum length 1.ProjectEnvironmentScopeobjectRecurringScheduleobjectEndAfterOccurrencesintegerEndDatestring
Formatdate-time.EndOnDatestring
Formatdate-time.EndTypeenum
Allowed values:Never,OnDate,AfterOccurrences.StartDatestring
Formatdate-time.Typeenum
Allowed values:Daily,Weekly,Monthly,Annually.UnitintegerUserUtcOffsetInMinutesinteger
Startstring
Formatdate-time.TenantProjectEnvironmentScopearray of objectEnvironmentIdstringProjectIdstringTenantIdstring
Example Response
{
"Description": "string",
"End": "2020-01-01T00:00:00.000Z",
"Id": "string",
"Name": "string",
"ProjectEnvironmentScope": {
"additionalProp1": [
"string"
],
"additionalProp2": [
"string"
],
"additionalProp3": [
"string"
]
},
"RecurringSchedule": {
"EndAfterOccurrences": 0,
"EndDate": "2020-01-01T00:00:00.000Z",
"EndOnDate": "2020-01-01T00:00:00.000Z",
"EndType": "Never",
"StartDate": "2020-01-01T00:00:00.000Z",
"Type": "Daily",
"Unit": 0,
"UserUtcOffsetInMinutes": 0
},
"Start": "2020-01-01T00:00:00.000Z",
"TenantProjectEnvironmentScope": [
{
"EnvironmentId": "Environments-1",
"ProjectId": "Projects-1",
"TenantId": "Tenants-1"
}
]
}Create a new deployment freeze
PUT /api
Path Parameters
idstring (required)
Request Body
DescriptionstringEndstring (required)
Formatdate-time.Idstring (required)Namestring (required)
Minimum length 1. Maximum length 200.ProjectEnvironmentScopeobjectRecurringScheduleobjectEndAfterOccurrencesintegerEndDatestring
Formatdate-time.EndOnDatestring
Formatdate-time.EndTypeenum
Allowed values:Never,OnDate,AfterOccurrences.StartDatestring
Formatdate-time.Typeenum
Allowed values:Daily,Weekly,Monthly,Annually.UnitintegerUserUtcOffsetInMinutesinteger
Startstring (required)
Formatdate-time.TenantProjectEnvironmentScopearray of objectEnvironmentIdstring (required)ProjectIdstring (required)TenantIdstring (required)
Response
200 — Modifies an existing deployment freeze
DescriptionstringEndstring
Formatdate-time.IdstringNamestring
Minimum length 1.ProjectEnvironmentScopeobjectRecurringScheduleobjectEndAfterOccurrencesintegerEndDatestring
Formatdate-time.EndOnDatestring
Formatdate-time.EndTypeenum
Allowed values:Never,OnDate,AfterOccurrences.StartDatestring
Formatdate-time.Typeenum
Allowed values:Daily,Weekly,Monthly,Annually.UnitintegerUserUtcOffsetInMinutesinteger
Startstring
Formatdate-time.TenantProjectEnvironmentScopearray of objectEnvironmentIdstringProjectIdstringTenantIdstring
Example Request
{
"Description": "string",
"End": "2020-01-01T00:00:00.000Z",
"Id": "string",
"Name": "string",
"ProjectEnvironmentScope": {
"additionalProp1": [
"string"
],
"additionalProp2": [
"string"
],
"additionalProp3": [
"string"
]
},
"RecurringSchedule": {
"EndAfterOccurrences": 0,
"EndDate": "2020-01-01T00:00:00.000Z",
"EndOnDate": "2020-01-01T00:00:00.000Z",
"EndType": "Never",
"StartDate": "2020-01-01T00:00:00.000Z",
"Type": "Daily",
"Unit": 0,
"UserUtcOffsetInMinutes": 0
},
"Start": "2020-01-01T00:00:00.000Z",
"TenantProjectEnvironmentScope": [
{
"EnvironmentId": "Environments-1",
"ProjectId": "Projects-1",
"TenantId": "Tenants-1"
}
]
}Example Response
{
"Description": "string",
"End": "2020-01-01T00:00:00.000Z",
"Id": "string",
"Name": "string",
"ProjectEnvironmentScope": {
"additionalProp1": [
"string"
],
"additionalProp2": [
"string"
],
"additionalProp3": [
"string"
]
},
"RecurringSchedule": {
"EndAfterOccurrences": 0,
"EndDate": "2020-01-01T00:00:00.000Z",
"EndOnDate": "2020-01-01T00:00:00.000Z",
"EndType": "Never",
"StartDate": "2020-01-01T00:00:00.000Z",
"Type": "Daily",
"Unit": 0,
"UserUtcOffsetInMinutes": 0
},
"Start": "2020-01-01T00:00:00.000Z",
"TenantProjectEnvironmentScope": [
{
"EnvironmentId": "Environments-1",
"ProjectId": "Projects-1",
"TenantId": "Tenants-1"
}
]
}Delete a deployment freeze
DELETE /api
Path Parameters
idstring (required)
ID of the DeploymentFreeze to delete.
Response
200 — Success
Override a deployment freeze to create a deployment
POST /api
Also reachable at /api, /api.
Path Parameters
spaceIdstring (required)
Request Body
CreateDeploymentCommandobject (required)ChangeRequestSettingsarray of objectChangesarray of objectChangesMarkdownstringChannelIdstringCommentsstringCreatedstring
Formatdate-time.DebugModestringDeployedBystringDeployedByIdstringDeployedToMachineIdsarray of stringDeploymentProcessIdstringEnvironmentIdstring (required)ExcludedMachineIdsarray of string
A collection of machines in the target environment that should be excluded from the deployment.ExcludedTargetTagIdsarray of string
A collection of target tag IDs that should be excluded from the deployment. Only deployment targets that have none of these tags will be deployed to. Tag IDs are in the format “TagSets-{id}/Tags-{id}”.ExecutionPlanLogContextobjectFailTargetDiscoverybooleanFailureEncounteredbooleanForcePackageDownloadbooleanForcePackageRedeploymentbooleanFormValuesobjectIdstring
Gets or sets a unique identifier for this resource.LastModifiedBystring
Gets or sets the username of the user who last modified this resource.LastModifiedOnstring
Gets or sets the date/time that this resource was last modified. Formatdate-time.Linksobject
Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.ManifestVariableSetIdstringNamestringPrioritystringProjectIdstringQueueTimestring
If set this time will be the used to schedule the deployment to a later time, null is assumed to mean the time will be executed immediately. Formatdate-time.QueueTimeExpirystring
Formatdate-time.ReleaseIdstring (required)SkipActionsarray of stringSpaceIdstringSpecificMachineIdsarray of string
A collection of machines in the target environment that should be deployed to. If the collection is empty, all enabled machines are deployed.SpecificTargetTagIdsarray of string
A collection of target tag IDs that should be included in the deployment. Only deployment targets that have at least one of these tags will be deployed to. Tag IDs are in the format “TagSets-{id}/Tags-{id}”.TaskIdstringTenantIdstringTentacleRetentionPeriodobjectUseGuidedFailureboolean
If set to true, the deployment will prompt for manual intervention (Fail/Retry/Ignore) when failures are encountered in activities that support it. May be overridden with the Octopus.UseGuidedFailure special variable.
FreezeIdsarray of string (required)Reasonstring (required)
Minimum length 1.SpaceIdstring (required)
Response
201 — Created
DeploymentobjectChangeRequestSettingsarray of objectChangesarray of objectChangesMarkdownstringChannelIdstringCommentsstringCreatedstring
Formatdate-time.DebugModestringDeployedBystringDeployedByIdstringDeployedToMachineIdsarray of stringDeploymentProcessIdstringEnvironmentIdstringExcludedMachineIdsarray of string
A collection of machines in the target environment that should be excluded from the deployment.ExcludedTargetTagIdsarray of string
A collection of target tag IDs that should be excluded from the deployment. Only deployment targets that have none of these tags will be deployed to. Tag IDs are in the format “TagSets-{id}/Tags-{id}”.ExecutionPlanLogContextobjectFailTargetDiscoverybooleanFailureEncounteredbooleanForcePackageDownloadbooleanForcePackageRedeploymentbooleanFormValuesobjectIdstring
Gets or sets a unique identifier for this resource.LastModifiedBystring
Gets or sets the username of the user who last modified this resource.LastModifiedOnstring
Gets or sets the date/time that this resource was last modified. Formatdate-time.Linksobject
Gets or sets a dictionary of links to other related resources. These links can be used to navigate the resources on the server.ManifestVariableSetIdstringNamestringPrioritystringProjectIdstringQueueTimestring
If set this time will be the used to schedule the deployment to a later time, null is assumed to mean the time will be executed immediately. Formatdate-time.QueueTimeExpirystring
Formatdate-time.ReleaseIdstringSkipActionsarray of stringSpaceIdstringSpecificMachineIdsarray of string
A collection of machines in the target environment that should be deployed to. If the collection is empty, all enabled machines are deployed.SpecificTargetTagIdsarray of string
A collection of target tag IDs that should be included in the deployment. Only deployment targets that have at least one of these tags will be deployed to. Tag IDs are in the format “TagSets-{id}/Tags-{id}”.TaskIdstringTenantIdstringTentacleRetentionPeriodobjectUseGuidedFailureboolean
If set to true, the deployment will prompt for manual intervention (Fail/Retry/Ignore) when failures are encountered in activities that support it. May be overridden with the Octopus.UseGuidedFailure special variable.
Example Request
{
"CreateDeploymentCommand": {
"ChangeRequestSettings": [
{
"Type": "ServiceNow"
}
],
"Changes": [
{
"BuildInformation": [
{}
],
"Commits": [
{}
],
"ReleaseNotes": "string",
"Version": "string",
"WorkItems": [
{}
]
}
],
"ChangesMarkdown": "string",
"ChannelId": "Channels-1",
"Comments": "string",
"Created": "2020-01-01T00:00:00.000Z",
"DebugMode": "string",
"DeployedBy": "string",
"DeployedById": "string",
"DeployedToMachineIds": [
"string"
],
"DeploymentProcessId": "string",
"EnvironmentId": "Environments-1",
"ExcludedMachineIds": [
"string"
],
"ExcludedTargetTagIds": [
"string"
],
"ExecutionPlanLogContext": {
"Steps": [
{}
]
},
"FailTargetDiscovery": true,
"FailureEncountered": true,
"ForcePackageDownload": true,
"ForcePackageRedeployment": true,
"FormValues": {
"additionalProp1": "string",
"additionalProp2": "string",
"additionalProp3": "string"
},
"Id": "Deployments-1",
"LastModifiedBy": "string",
"LastModifiedOn": "2020-01-01T00:00:00.000Z",
"Links": {
"additionalProp1": "string",
"additionalProp2": "string",
"additionalProp3": "string"
},
"ManifestVariableSetId": "string",
"Name": "string",
"Priority": "string",
"ProjectId": "Projects-1",
"QueueTime": "2020-01-01T00:00:00.000Z",
"QueueTimeExpiry": "2020-01-01T00:00:00.000Z",
"ReleaseId": "Releases-1",
"SkipActions": [
"string"
],
"SpaceId": "Spaces-1",
"SpecificMachineIds": [
"string"
],
"SpecificTargetTagIds": [
"string"
],
"TaskId": "ServerTasks-1",
"TenantId": "Tenants-1",
"TentacleRetentionPeriod": {
"QuantityToKeep": 0,
"ShouldKeepForever": true,
"Strategy": "string",
"Unit": "Days"
},
"UseGuidedFailure": true
},
"FreezeIds": [
"string"
],
"Reason": "string",
"SpaceId": "Spaces-1"
}Example Response
{
"Deployment": {
"ChangeRequestSettings": [
{
"Type": "ServiceNow"
}
],
"Changes": [
{
"BuildInformation": [
{}
],
"Commits": [
{}
],
"ReleaseNotes": "string",
"Version": "string",
"WorkItems": [
{}
]
}
],
"ChangesMarkdown": "string",
"ChannelId": "Channels-1",
"Comments": "string",
"Created": "2020-01-01T00:00:00.000Z",
"DebugMode": "string",
"DeployedBy": "string",
"DeployedById": "string",
"DeployedToMachineIds": [
"string"
],
"DeploymentProcessId": "string",
"EnvironmentId": "Environments-1",
"ExcludedMachineIds": [
"string"
],
"ExcludedTargetTagIds": [
"string"
],
"ExecutionPlanLogContext": {
"Steps": [
{}
]
},
"FailTargetDiscovery": true,
"FailureEncountered": true,
"ForcePackageDownload": true,
"ForcePackageRedeployment": true,
"FormValues": {
"additionalProp1": "string",
"additionalProp2": "string",
"additionalProp3": "string"
},
"Id": "Deployments-1",
"LastModifiedBy": "string",
"LastModifiedOn": "2020-01-01T00:00:00.000Z",
"Links": {
"additionalProp1": "string",
"additionalProp2": "string",
"additionalProp3": "string"
},
"ManifestVariableSetId": "string",
"Name": "string",
"Priority": "string",
"ProjectId": "Projects-1",
"QueueTime": "2020-01-01T00:00:00.000Z",
"QueueTimeExpiry": "2020-01-01T00:00:00.000Z",
"ReleaseId": "Releases-1",
"SkipActions": [
"string"
],
"SpaceId": "Spaces-1",
"SpecificMachineIds": [
"string"
],
"SpecificTargetTagIds": [
"string"
],
"TaskId": "ServerTasks-1",
"TenantId": "Tenants-1",
"TentacleRetentionPeriod": {
"QuantityToKeep": 0,
"ShouldKeepForever": true,
"Strategy": "string",
"Unit": "Days"
},
"UseGuidedFailure": true
}
}